# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PtsV2PaymentsPost201ResponseInstallmentInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'additional_costs': 'str',
        'additional_costs_percentage': 'str',
        'amount_funded': 'str',
        'amount_requested_percentage': 'str',
        'annual_financing_cost': 'str',
        'annual_interest_rate': 'str',
        'expenses': 'str',
        'expenses_percentage': 'str',
        'fees': 'str',
        'fees_percentage': 'str',
        'insurance': 'str',
        'insurance_percentage': 'str',
        'monthly_interest_rate': 'str',
        'taxes': 'str',
        'taxes_percentage': 'str'
    }

    attribute_map = {
        'additional_costs': 'additionalCosts',
        'additional_costs_percentage': 'additionalCostsPercentage',
        'amount_funded': 'amountFunded',
        'amount_requested_percentage': 'amountRequestedPercentage',
        'annual_financing_cost': 'annualFinancingCost',
        'annual_interest_rate': 'annualInterestRate',
        'expenses': 'expenses',
        'expenses_percentage': 'expensesPercentage',
        'fees': 'fees',
        'fees_percentage': 'feesPercentage',
        'insurance': 'insurance',
        'insurance_percentage': 'insurancePercentage',
        'monthly_interest_rate': 'monthlyInterestRate',
        'taxes': 'taxes',
        'taxes_percentage': 'taxesPercentage'
    }

    def __init__(self, additional_costs=None, additional_costs_percentage=None, amount_funded=None, amount_requested_percentage=None, annual_financing_cost=None, annual_interest_rate=None, expenses=None, expenses_percentage=None, fees=None, fees_percentage=None, insurance=None, insurance_percentage=None, monthly_interest_rate=None, taxes=None, taxes_percentage=None):
        """
        PtsV2PaymentsPost201ResponseInstallmentInformation - a model defined in Swagger
        """

        self._additional_costs = None
        self._additional_costs_percentage = None
        self._amount_funded = None
        self._amount_requested_percentage = None
        self._annual_financing_cost = None
        self._annual_interest_rate = None
        self._expenses = None
        self._expenses_percentage = None
        self._fees = None
        self._fees_percentage = None
        self._insurance = None
        self._insurance_percentage = None
        self._monthly_interest_rate = None
        self._taxes = None
        self._taxes_percentage = None

        if additional_costs is not None:
          self.additional_costs = additional_costs
        if additional_costs_percentage is not None:
          self.additional_costs_percentage = additional_costs_percentage
        if amount_funded is not None:
          self.amount_funded = amount_funded
        if amount_requested_percentage is not None:
          self.amount_requested_percentage = amount_requested_percentage
        if annual_financing_cost is not None:
          self.annual_financing_cost = annual_financing_cost
        if annual_interest_rate is not None:
          self.annual_interest_rate = annual_interest_rate
        if expenses is not None:
          self.expenses = expenses
        if expenses_percentage is not None:
          self.expenses_percentage = expenses_percentage
        if fees is not None:
          self.fees = fees
        if fees_percentage is not None:
          self.fees_percentage = fees_percentage
        if insurance is not None:
          self.insurance = insurance
        if insurance_percentage is not None:
          self.insurance_percentage = insurance_percentage
        if monthly_interest_rate is not None:
          self.monthly_interest_rate = monthly_interest_rate
        if taxes is not None:
          self.taxes = taxes
        if taxes_percentage is not None:
          self.taxes_percentage = taxes_percentage

    @property
    def additional_costs(self):
        """
        Gets the additional_costs of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Additional costs charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 128-139 - Field: Total Other Costs 

        :return: The additional_costs of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._additional_costs

    @additional_costs.setter
    def additional_costs(self, additional_costs):
        """
        Sets the additional_costs of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Additional costs charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 128-139 - Field: Total Other Costs 

        :param additional_costs: The additional_costs of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._additional_costs = additional_costs

    @property
    def additional_costs_percentage(self):
        """
        Gets the additional_costs_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Additional costs divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 140-143 - Field: Percent of Total Other Costs 

        :return: The additional_costs_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._additional_costs_percentage

    @additional_costs_percentage.setter
    def additional_costs_percentage(self, additional_costs_percentage):
        """
        Sets the additional_costs_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Additional costs divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 140-143 - Field: Percent of Total Other Costs 

        :param additional_costs_percentage: The additional_costs_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._additional_costs_percentage = additional_costs_percentage

    @property
    def amount_funded(self):
        """
        Gets the amount_funded of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Amount funded.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 48-59 - Field: Total Amount Funded 

        :return: The amount_funded of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._amount_funded

    @amount_funded.setter
    def amount_funded(self, amount_funded):
        """
        Sets the amount_funded of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Amount funded.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 48-59 - Field: Total Amount Funded 

        :param amount_funded: The amount_funded of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._amount_funded = amount_funded

    @property
    def amount_requested_percentage(self):
        """
        Gets the amount_requested_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Amount requested divided by the amount funded.  For example: - A value of 90.0 specifies 90%. - A value of 93.7 specifies 93.7%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 60-63 - Field: Percent of Amount Requested 

        :return: The amount_requested_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._amount_requested_percentage

    @amount_requested_percentage.setter
    def amount_requested_percentage(self, amount_requested_percentage):
        """
        Sets the amount_requested_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Amount requested divided by the amount funded.  For example: - A value of 90.0 specifies 90%. - A value of 93.7 specifies 93.7%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 60-63 - Field: Percent of Amount Requested 

        :param amount_requested_percentage: The amount_requested_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._amount_requested_percentage = amount_requested_percentage

    @property
    def annual_financing_cost(self):
        """
        Gets the annual_financing_cost of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Annual cost of financing the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 158-164 - Field: Annual Total Cost of Financing 

        :return: The annual_financing_cost of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._annual_financing_cost

    @annual_financing_cost.setter
    def annual_financing_cost(self, annual_financing_cost):
        """
        Sets the annual_financing_cost of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Annual cost of financing the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 158-164 - Field: Annual Total Cost of Financing 

        :param annual_financing_cost: The annual_financing_cost of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._annual_financing_cost = annual_financing_cost

    @property
    def annual_interest_rate(self):
        """
        Gets the annual_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Annual interest rate.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 151-157 - Field: Annual Interest Rate 

        :return: The annual_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._annual_interest_rate

    @annual_interest_rate.setter
    def annual_interest_rate(self, annual_interest_rate):
        """
        Sets the annual_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Annual interest rate.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 151-157 - Field: Annual Interest Rate 

        :param annual_interest_rate: The annual_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._annual_interest_rate = annual_interest_rate

    @property
    def expenses(self):
        """
        Gets the expenses of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Expenses charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 64-75 - Field: Total Expenses 

        :return: The expenses of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._expenses

    @expenses.setter
    def expenses(self, expenses):
        """
        Sets the expenses of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Expenses charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 64-75 - Field: Total Expenses 

        :param expenses: The expenses of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._expenses = expenses

    @property
    def expenses_percentage(self):
        """
        Gets the expenses_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Expenses divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 76-79 - Field: Percent of Total Expenses 

        :return: The expenses_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._expenses_percentage

    @expenses_percentage.setter
    def expenses_percentage(self, expenses_percentage):
        """
        Sets the expenses_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Expenses divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 76-79 - Field: Percent of Total Expenses 

        :param expenses_percentage: The expenses_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._expenses_percentage = expenses_percentage

    @property
    def fees(self):
        """
        Gets the fees of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Fees charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 80-91 - Field: Total Fees 

        :return: The fees of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._fees

    @fees.setter
    def fees(self, fees):
        """
        Sets the fees of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Fees charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 80-91 - Field: Total Fees 

        :param fees: The fees of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._fees = fees

    @property
    def fees_percentage(self):
        """
        Gets the fees_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Fees divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on CyberSource through VisaNet.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 92-95 - Field: Percent of Total Fees 

        :return: The fees_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._fees_percentage

    @fees_percentage.setter
    def fees_percentage(self, fees_percentage):
        """
        Sets the fees_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Fees divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on CyberSource through VisaNet.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 92-95 - Field: Percent of Total Fees 

        :param fees_percentage: The fees_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._fees_percentage = fees_percentage

    @property
    def insurance(self):
        """
        Gets the insurance of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Insurance charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 112-123 - Field: Total Insurance 

        :return: The insurance of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._insurance

    @insurance.setter
    def insurance(self, insurance):
        """
        Sets the insurance of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Insurance charged by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 112-123 - Field: Total Insurance 

        :param insurance: The insurance of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._insurance = insurance

    @property
    def insurance_percentage(self):
        """
        Gets the insurance_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Insurance costs divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 124-127 - Field: Percent Of Total Insurance 

        :return: The insurance_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._insurance_percentage

    @insurance_percentage.setter
    def insurance_percentage(self, insurance_percentage):
        """
        Sets the insurance_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Insurance costs divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 124-127 - Field: Percent Of Total Insurance 

        :param insurance_percentage: The insurance_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._insurance_percentage = insurance_percentage

    @property
    def monthly_interest_rate(self):
        """
        Gets the monthly_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Monthly interest rate.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 144-150 - Field: Monthly Interest Rate 

        :return: The monthly_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._monthly_interest_rate

    @monthly_interest_rate.setter
    def monthly_interest_rate(self, monthly_interest_rate):
        """
        Sets the monthly_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Monthly interest rate.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 144-150 - Field: Monthly Interest Rate 

        :param monthly_interest_rate: The monthly_interest_rate of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._monthly_interest_rate = monthly_interest_rate

    @property
    def taxes(self):
        """
        Gets the taxes of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Taxes collected by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 96-107 - Field: Total Taxes 

        :return: The taxes of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._taxes

    @taxes.setter
    def taxes(self, taxes):
        """
        Sets the taxes of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Taxes collected by the issuer to fund the installment payments.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 96-107 - Field: Total Taxes 

        :param taxes: The taxes of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._taxes = taxes

    @property
    def taxes_percentage(self):
        """
        Gets the taxes_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Taxes divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 108-111 - Field: Percent of Total Taxes 

        :return: The taxes_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :rtype: str
        """
        return self._taxes_percentage

    @taxes_percentage.setter
    def taxes_percentage(self, taxes_percentage):
        """
        Sets the taxes_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        Taxes divided by the amount funded.  For example: - A value of 1.0 specifies 1%. - A value of 4.0 specifies 4%.  This field is included in the authorization reply for the Crediario eligibility request when the issuer approves the cardholder's request for Crediario installment payments in Brazil.  For details, see \"Installment Payments on CyberSource through VisaNet\" in the [Credit Card Services Using the SCMP API Guide.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/wwhelp/wwhimpl/js/html/wwhelp.htm)  This field is supported only for Crediario installment payments in Brazil on **CyberSource through VisaNet**.  The value for this field corresponds to the following data in the TC 33 capture file1: - Record: CP01 TCR9 - Position: 108-111 - Field: Percent of Total Taxes 

        :param taxes_percentage: The taxes_percentage of this PtsV2PaymentsPost201ResponseInstallmentInformation.
        :type: str
        """

        self._taxes_percentage = taxes_percentage

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PtsV2PaymentsPost201ResponseInstallmentInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
